#!/usr/bin/env python

import numpy as np
from osgeo import gdal

def complex_spurce_bug():
    xsize = ysize = 100
    data = np.ones((ysize, xsize), np.complex64)
    data.imag = 3 * data.real

    datafile = 'data.tif'
    drv = gdal.GetDriverByName('GTiff')
    ds = drv.Create(datafile, xsize, ysize, 1, gdal.GDT_CFloat32)
    b = ds.GetRasterBand(1)
    b.WriteArray(data)
    b.FlushCache()
    del b, ds


    ds = gdal.Open(datafile)
    b = ds.GetRasterBand(1)
    readdata = b.ReadAsArray()
    del b, ds

    complex_xml = '''<VRTDataset rasterXSize="100" rasterYSize="100">
  <VRTRasterBand dataType="CFloat32" band="1">
    <ComplexSource>
      <SourceFilename relativeToVRT="1">data.tif</SourceFilename>
      <SourceBand>1</SourceBand>
      <ScaleOffset>0</ScaleOffset>
      <ScaleRatio>2</ScaleRatio>
    </ComplexSource>
  </VRTRasterBand>
</VRTDataset>
'''


    vrtfile = 'data.vrt'
    with file(vrtfile, 'w') as fd:
        fd.write(complex_xml)

    ds = gdal.Open(vrtfile)
    b = ds.GetRasterBand(1)
    scaleddata = b.ReadAsArray()
    del b, ds

    print 'ScaleRatio:', 2
    print 'readdata[0, 0]:', readdata[0, 0]
    print 'scaleddata[0, 0]:', scaleddata[0, 0]


if __name__ == '__main__':
    complex_spurce_bug()
